VERSION 5.00
Object = "{3D35C49E-E22C-4AF8-ABD6-F45ADFF5599C}#1.0#0"; "RegObj.ocx"
Begin VB.Form frmNetFinder 
   Caption         =   "Windows 98 NIC IP Address Editor"
   ClientHeight    =   2040
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   5268
   LinkTopic       =   "Form1"
   ScaleHeight     =   2040
   ScaleWidth      =   5268
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   372
      Left            =   3840
      TabIndex        =   5
      Top             =   1200
      Width           =   1332
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "&Update IP Addr"
      Enabled         =   0   'False
      Height          =   372
      Left            =   3840
      TabIndex        =   4
      Top             =   720
      Width           =   1332
   End
   Begin VB.CommandButton cmdFind 
      Caption         =   "&Find IP Addr"
      Height          =   372
      Left            =   3840
      TabIndex        =   3
      Top             =   240
      Width           =   1332
   End
   Begin VB.Frame frmNICData 
      Caption         =   "NIC Information"
      Height          =   1452
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3612
      Begin VB.TextBox txtIPMask 
         Height          =   288
         Left            =   1320
         TabIndex        =   11
         Text            =   "255.255.255.255"
         Top             =   600
         Width           =   2172
      End
      Begin VB.TextBox txtIPAddress 
         Height          =   288
         Left            =   1320
         TabIndex        =   7
         Text            =   "0.0.0.0"
         Top             =   240
         Width           =   2172
      End
      Begin VB.Label lblIPMask 
         Caption         =   "IP Mask:"
         Height          =   252
         Left            =   120
         TabIndex        =   10
         Top             =   720
         Width           =   1092
      End
      Begin VB.Label lblRegNode 
         BorderStyle     =   1  'Fixed Single
         Caption         =   "9999"
         Height          =   288
         Left            =   1320
         TabIndex        =   9
         Top             =   960
         Width           =   2172
      End
      Begin VB.Label lblRegNodeTag 
         Caption         =   "Registry Node:"
         Height          =   252
         Left            =   120
         TabIndex        =   8
         Top             =   1080
         Width           =   1092
      End
      Begin VB.Label lblIPAddress 
         Caption         =   "IP Address:"
         Height          =   252
         Left            =   120
         TabIndex        =   6
         Top             =   360
         Width           =   1092
      End
   End
   Begin REGOBJLibCtl.RegistryObject ocxRegistryObject 
      Left            =   3840
      OleObjectBlob   =   "NetFinder.frx":0000
      Top             =   1560
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   252
      Left            =   720
      TabIndex        =   2
      Top             =   1680
      Width           =   3012
   End
   Begin VB.Label lblStatusTag 
      Caption         =   "Status:"
      Height          =   252
      Left            =   120
      TabIndex        =   1
      Top             =   1680
      Width           =   612
   End
End
Attribute VB_Name = "frmNetFinder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim strCounter As String
Dim strBasicKey As String
Dim strSearchKey As String


Private Sub cmdExit_Click()
    End
End Sub

Private Sub cmdFind_Click()
    'The idea is to open the Windows 98 Registry
    'key that contains the NIC address. The Registry
    'key always begins with this:
    '
    'HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\Class\NetTrans
    '
    'Subkeys ("0000" thru "nnnn") contain
    'the actual network information. The
    'subkey that contains the actual NIC
    'information, versus dial-up networking
    'information, has a value of "1"
    'for "NodeType". If we loop through the
    'subkeys looking for this value, we
    'should find the node with the NIC
    'IP Address. We will assume no more than
    '20 subkeys, which for all practical purposes
    'should do the trick.
    Dim iCounter As Integer
    Dim varValue As Variant
    Dim bFound As Boolean
    bFound = False
        
    On Error GoTo ErrFound
    
    'Disable the update button in case of
    'error...
    cmdUpdate.Enabled = False
    
    'Create a new Registry key for searching
    For iCounter = 0 To 5
        'Concatenate the counter with the
        'basic key string. Note we have to
        'pad with leading zeros...
        strCounter = "00" & iCounter
        If Len(strCounter) < 4 Then
            strCounter = "0" & strCounter
        End If
        strSearchKey = strBasicKey & strCounter
        
        'Open the resulting key
        ocxRegistryObject.OpenKey HKLM, strSearchKey
        
        'Query for the "NodeType" value
        ocxRegistryObject.QueryValue "NodeType", varValue
        
        If CStr(varValue) = "1" Then
            bFound = True
            cmdUpdate.Enabled = True
            Exit For
        End If
    Next

    'Fill in data
    If bFound = True Then
        'Pull values!
        ocxRegistryObject.QueryValue "IPAddress", varValue
        txtIPAddress.Text = CStr(varValue)
        ocxRegistryObject.QueryValue "IPMask", varValue
        txtIPMask.Text = CStr(varValue)
        lblRegNode.Caption = strCounter
        lblStatus.Caption = "Registry node found!"
    Else
        'Fill in status
        txtIPAddress.Text = "0.0.0.0"
        txtIPMask.Text = "255.255.255.255"
        lblRegNode.Caption = "9999"
        lblStatus.Caption = "Unable to locate network nodes!"
    End If
    
    'Reset error handler
    On Error GoTo 0
Exit Sub
ErrFound:
    Select Case Err.Number
    Case -2147024890
        'E_HANDLE, which is returned if the key/value
        'does not exist. We expect this condition, so
        'we just keep moving...
        Resume Next
    Case Else
        'This we didn't expect...we'll keep going, but
        'we'll notify the user...
        MsgBox "Unspecified application error!"
        Resume Next
    End Select
End Sub


Private Sub cmdUpdate_Click()
    'With the Registry key found we can
    'now update the IP address and subnet
    'mask, if we wish...
    Dim varValue As Variant
    
    On Error GoTo ErrFound
    
    'Store the new IP Address
    varValue = txtIPAddress.Text
    ocxRegistryObject.SetValue "IPAddress", CStr(varValue)
        
    'Store the new subnet mask
    varValue = txtIPMask.Text
    ocxRegistryObject.SetValue "IPMask", CStr(varValue)
        
    'Update status
    lblStatus.Caption = "Registry updated!"
    
    'Reset error handler
    On Error GoTo 0
Exit Sub
ErrFound:
    Select Case Err.Number
    Case -2147024890
        'E_HANDLE, which is returned if the key/value
        'does not exist or the key has become invalid.
        cmdUpdate.Enabled = False
        MsgBox "Registry key is now invalid...re-find the network information."
        Resume Next
    Case Else
        'This we didn't expect...we'll keep going, but
        'we'll notify the user...
        MsgBox "Unspecified application error!"
        Resume Next
    End Select
End Sub

Private Sub Form_Load()
    'Initialize the basic string
    strBasicKey = "System\CurrentControlSet\Services\Class\NetTrans\"
End Sub
